=== modified file 'configure.ac'
--- configure.ac	2009-04-09 01:11:00 +0000
+++ configure.ac	2009-04-09 05:35:58 +0000
@@ -1372,7 +1372,7 @@
   fi
 
   CC_WARNINGS="-v -errtags=yes -erroff=E_ATTRIBUTE_NOT_VAR ${W_FAIL}"
-  CXX_WARNINGS="+w +w2 -xport64 -errtags=yes -erroff=attrskipunsup,doubunder,reftotemp,inllargeuse,truncwarn1,signextwarn ${W_FAIL}" 
+  CXX_WARNINGS="+w +w2 -xport64 -errtags=yes -erroff=attrskipunsup,doubunder,reftotemp,inllargeuse,truncwarn1,signextwarn,inllargeint ${W_FAIL}" 
   PROTOSKIP_WARNINGS="-erroff=attrskipunsup,doubunder,reftotemp,wbadinitl,identexpected,inllargeuse,truncwarn1,signextwarn"
   NO_UNREACHED="-erroff=E_STATEMENT_NOT_REACHED"
   if test "$ac_exceptions" = "no"

=== modified file 'drizzled/Makefile.am'
--- drizzled/Makefile.am	2009-04-09 01:11:00 +0000
+++ drizzled/Makefile.am	2009-04-09 05:35:58 +0000
@@ -283,6 +283,7 @@
 		qcache.h \
 		query_arena.h \
 		query_id.h \
+		registry.h \
 		rename.h \
 		replicator.h \
 		scheduling.h \
@@ -351,7 +352,7 @@
 
 LDADD = $(top_builddir)/mysys/libmysys.la \
 	$(top_builddir)/mystrings/libmystrings.la \
-	$(LIBDRIZZLE) $(LIBZ) $(LIBINTL) ${LIBC_P}
+	$(LTLIBDRIZZLE) $(LIBZ) $(LIBINTL) ${LIBC_P}
 
 drizzled_LDADD = ${noinst_LTLIBRARIES} \
 		 $(top_builddir)/drizzled/serialize/libserialize.la \

=== modified file 'drizzled/db.cc'
--- drizzled/db.cc	2009-04-03 07:10:07 +0000
+++ drizzled/db.cc	2009-04-09 04:53:29 +0000
@@ -651,7 +651,6 @@
         presumably this was to avoid deleting other user data... except if that
         data happened to be in files ending in .BAK, .opt or .TMD. *fun*
        */
-      find_type(extension, ha_known_exts(),1+2);
       continue;
     }
     /* just for safety we use files_charset_info */

=== modified file 'drizzled/drizzled.cc'
--- drizzled/drizzled.cc	2009-04-09 01:11:00 +0000
+++ drizzled/drizzled.cc	2009-04-09 18:05:30 +0000
@@ -390,7 +390,7 @@
 pthread_rwlock_t	LOCK_system_variables_hash;
 pthread_cond_t COND_refresh, COND_thread_count, COND_global_read_lock;
 pthread_t signal_thread;
-pthread_cond_t  COND_server_started;
+pthread_cond_t  COND_server_end;
 
 /* replication parameters, if master_host is not NULL, we are a slave */
 uint32_t report_port= DRIZZLE_PORT;
@@ -527,9 +527,8 @@
       break;
     }
     (void) pthread_mutex_unlock(&LOCK_thread_count);
-    unlink_session(tmp);
+    tmp->protocol->forceClose();
   }
-  assert(session_list.is_empty());
 }
 
 
@@ -616,7 +615,7 @@
   (void) pthread_mutex_lock(&LOCK_thread_count);
   ready_to_exit=1;
   /* do the broadcast inside the lock to ensure that my_end() is not called */
-  (void) pthread_cond_broadcast(&COND_thread_count);
+  (void) pthread_cond_broadcast(&COND_server_end);
   (void) pthread_mutex_unlock(&LOCK_thread_count);
 
   /*
@@ -637,6 +636,7 @@
   (void) pthread_rwlock_destroy(&LOCK_system_variables_hash);
   (void) pthread_mutex_destroy(&LOCK_global_read_lock);
   (void) pthread_cond_destroy(&COND_thread_count);
+  (void) pthread_cond_destroy(&COND_server_end);
   (void) pthread_cond_destroy(&COND_refresh);
   (void) pthread_cond_destroy(&COND_global_read_lock);
 }
@@ -1507,6 +1507,7 @@
   (void) pthread_rwlock_init(&LOCK_system_variables_hash, NULL);
   (void) pthread_mutex_init(&LOCK_global_read_lock, MY_MUTEX_INIT_FAST);
   (void) pthread_cond_init(&COND_thread_count,NULL);
+  (void) pthread_cond_init(&COND_server_end,NULL);
   (void) pthread_cond_init(&COND_refresh,NULL);
   (void) pthread_cond_init(&COND_global_read_lock,NULL);
 
@@ -1597,23 +1598,28 @@
   }
 
   /*
+    This is entirely for legacy. We will create a new "disk based" engine and a
+    "memory" engine which will be configurable longterm. We should be able to
+    remove partition and myisammrg.
+  */
+  const LEX_STRING myisam_engine_name= { C_STRING_WITH_LEN("MyISAM") };
+  const LEX_STRING heap_engine_name= { C_STRING_WITH_LEN("MEMORY") };
+  myisam_engine= ha_resolve_by_name(NULL, &myisam_engine_name);
+  heap_engine= ha_resolve_by_name(NULL, &heap_engine_name);
+
+  /*
     Check that the default storage engine is actually available.
   */
   if (default_storage_engine_str)
   {
     LEX_STRING name= { default_storage_engine_str,
                        strlen(default_storage_engine_str) };
-    st_plugin_int *plugin;
     StorageEngine *engine;
 
-    if ((plugin= ha_resolve_by_name(0, &name)))
-    {
-      engine= static_cast<StorageEngine *>(plugin->data);
-    }
-    else
-    {
-          errmsg_printf(ERRMSG_LVL_ERROR, _("Unknown/unsupported table type: %s"),
-                      default_storage_engine_str);
+    if (!(engine= ha_resolve_by_name(0, &name)))
+    {
+      errmsg_printf(ERRMSG_LVL_ERROR, _("Unknown/unsupported table type: %s"),
+                    default_storage_engine_str);
       unireg_abort(1);
     }
     if (!engine->is_enabled())
@@ -1621,15 +1627,15 @@
       errmsg_printf(ERRMSG_LVL_ERROR, _("Default storage engine (%s) is not available"),
                     default_storage_engine_str);
       unireg_abort(1);
-      //assert(global_system_variables.table_plugin);
+      //assert(global_system_variables.storage_engine);
     }
     else
     {
       /*
-        Need to unlock as global_system_variables.table_plugin
+        Need to unlock as global_system_variables.storage_engine
         was acquired during plugin_init()
       */
-      global_system_variables.table_plugin= plugin;
+      global_system_variables.storage_engine= engine;
     }
   }
 
@@ -1791,7 +1797,7 @@
   /* Wait until cleanup is done */
   (void) pthread_mutex_lock(&LOCK_thread_count);
   while (!ready_to_exit)
-    pthread_cond_wait(&COND_thread_count,&LOCK_thread_count);
+    pthread_cond_wait(&COND_server_end,&LOCK_thread_count);
   (void) pthread_mutex_unlock(&LOCK_thread_count);
 
   clean_up(1);
@@ -2765,7 +2771,7 @@
   lc_time_names_name= (char*) "en_US";
   /* Set default values for some option variables */
   default_storage_engine_str= (char*) "innodb";
-  global_system_variables.table_plugin= NULL;
+  global_system_variables.storage_engine= NULL;
   global_system_variables.tx_isolation= ISO_REPEATABLE_READ;
   global_system_variables.select_limit= (uint64_t) HA_POS_ERROR;
   max_system_variables.select_limit=    (uint64_t) HA_POS_ERROR;

=== modified file 'drizzled/function/create.h'
--- drizzled/function/create.h	2009-03-20 04:05:09 +0000
+++ drizzled/function/create.h	2009-04-08 09:13:23 +0000
@@ -26,20 +26,33 @@
 #include <drizzled/item/bin_string.h>
 
 #include <string>
+#include <vector>
 #include <functional>
 
 class Function_builder
   : public std::unary_function<MEM_ROOT*, Item_func *>
 {
   std::string name;
+  std::vector<std::string> aliases;
 public:
   Function_builder(std::string in_name) : name(in_name) {}
+  Function_builder(const char *in_name) : name(in_name) {}
   virtual result_type operator()(argument_type session) const= 0;
   virtual ~Function_builder() {}
 
-  std::string get_name() const
-  {
-      return name;
+  std::string getName() const
+  {
+    return name;
+  }
+
+  const std::vector<std::string>& getAliases() const
+  {
+    return aliases;
+  }
+
+  void addAlias(std::string alias)
+  {
+    aliases.push_back(alias);
   }
 };
 
@@ -49,6 +62,7 @@
 public:
   typedef T Function_class;
   Create_function(std::string in_name): Function_builder(in_name) {}
+  Create_function(const char *in_name): Function_builder(in_name) {}
   virtual result_type operator()(argument_type root) const
   {
     return new (root) Function_class();

=== modified file 'drizzled/handler.cc'
--- drizzled/handler.cc	2009-04-09 05:42:03 +0000
+++ drizzled/handler.cc	2009-04-09 23:30:44 +0000
@@ -63,9 +63,6 @@
 TYPELIB tx_isolation_typelib= {array_elements(tx_isolation_names)-1,"",
                                tx_isolation_names, NULL};
 
-static TYPELIB known_extensions= {0,"known_exts", NULL, NULL};
-uint32_t known_extensions_id= 0;
-
 
 /**
   Register handler error messages for use with my_error().
@@ -183,46 +180,7 @@
   return(error);
 }
 
-static bool dropdb_storage_engine(Session *,
-                                  st_plugin_int *plugin,
-                                  void *path)
-{
-  StorageEngine *engine= plugin_data(plugin, StorageEngine *);
-  if (engine->is_enabled())
-    engine->drop_database((char *)path);
-  return false;
-}
-
-
-void ha_drop_database(char* path)
-{
-  plugin_foreach(NULL, dropdb_storage_engine, DRIZZLE_STORAGE_ENGINE_PLUGIN, path);
-}
-
-
-static bool closecon_storage_engine(Session *session, st_plugin_int *plugin,
-                                void *)
-{
-  StorageEngine *engine= plugin_data(plugin, StorageEngine *);
-  /*
-    there's no need to rollback here as all transactions must
-    be rolled back already
-  */
-  if (engine->is_enabled() && 
-      session_get_ha_data(session, engine))
-    engine->close_connection(session);
-  return false;
-}
-
-
-/**
-  @note
-    don't bother to rollback here, it's done already
-*/
-void ha_close_connection(Session* session)
-{
-  plugin_foreach(session, closecon_storage_engine, DRIZZLE_STORAGE_ENGINE_PLUGIN, 0);
-}
+
 
 /* ========================================================================
  ======================= TRANSACTIONS ===================================*/
@@ -864,189 +822,7 @@
 }
 
 
-struct xaengine_st {
-  XID *xid;
-  int result;
-};
-
-static bool xacommit_storage_engine(Session *,
-                                    st_plugin_int *plugin,
-                                    void *arg)
-{
-  StorageEngine *engine= plugin_data(plugin, StorageEngine *);
-  if (engine->is_enabled())
-  {
-    engine->commit_by_xid(((struct xaengine_st *)arg)->xid);
-    ((struct xaengine_st *)arg)->result= 0;
-  }
-  return false;
-}
-
-static bool xarollback_storage_engine(Session *,
-                                      st_plugin_int *plugin,
-                                  void *arg)
-{
-  StorageEngine *engine= plugin_data(plugin, StorageEngine *);
-  if (engine->is_enabled())
-  {
-    engine->rollback_by_xid(((struct xaengine_st *)arg)->xid);
-    ((struct xaengine_st *)arg)->result= 0;
-  }
-  return false;
-}
-
-
-int ha_commit_or_rollback_by_xid(XID *xid, bool commit)
-{
-  struct xaengine_st xaop;
-  xaop.xid= xid;
-  xaop.result= 1;
-
-  plugin_foreach(NULL, commit ? xacommit_storage_engine : xarollback_storage_engine,
-                 DRIZZLE_STORAGE_ENGINE_PLUGIN, &xaop);
-
-  return xaop.result;
-}
-
-/**
-  recover() step of xa.
-
-  @note
-    there are three modes of operation:
-    - automatic recover after a crash
-    in this case commit_list != 0, tc_heuristic_recover==0
-    all xids from commit_list are committed, others are rolled back
-    - manual (heuristic) recover
-    in this case commit_list==0, tc_heuristic_recover != 0
-    DBA has explicitly specified that all prepared transactions should
-    be committed (or rolled back).
-    - no recovery (MySQL did not detect a crash)
-    in this case commit_list==0, tc_heuristic_recover == 0
-    there should be no prepared transactions in this case.
-*/
-struct xarecover_st
-{
-  int len, found_foreign_xids, found_my_xids;
-  XID *list;
-  HASH *commit_list;
-  bool dry_run;
-};
-
-static bool xarecover_storage_engine(Session *,
-                                     st_plugin_int *plugin,
-                                     void *arg)
-{
-  StorageEngine *engine= plugin_data(plugin, StorageEngine *);
-  struct xarecover_st *info= (struct xarecover_st *) arg;
-  int got;
-
-  if (engine->is_enabled())
-  {
-    while ((got= engine->recover(info->list, info->len)) > 0 )
-    {
-      errmsg_printf(ERRMSG_LVL_INFO,
-                    _("Found %d prepared transaction(s) in %s"),
-                    got, engine->getName().c_str());
-      for (int i=0; i < got; i ++)
-      {
-        my_xid x=info->list[i].get_my_xid();
-        if (!x) // not "mine" - that is generated by external TM
-        {
-          xid_cache_insert(info->list+i, XA_PREPARED);
-          info->found_foreign_xids++;
-          continue;
-        }
-        if (info->dry_run)
-        {
-          info->found_my_xids++;
-          continue;
-        }
-        // recovery mode
-        if (info->commit_list ?
-            hash_search(info->commit_list, (unsigned char *)&x, sizeof(x)) != 0 :
-            tc_heuristic_recover == TC_HEURISTIC_RECOVER_COMMIT)
-        {
-          engine->commit_by_xid(info->list+i);
-        }
-        else
-        {
-          engine->rollback_by_xid(info->list+i);
-        }
-      }
-      if (got < info->len)
-        break;
-    }
-  }
-  return false;
-}
-
-int ha_recover(HASH *commit_list)
-{
-  struct xarecover_st info;
-  info.found_foreign_xids= info.found_my_xids= 0;
-  info.commit_list= commit_list;
-  info.dry_run= (info.commit_list==0 && tc_heuristic_recover==0);
-  info.list= NULL;
-
-  /* commit_list and tc_heuristic_recover cannot be set both */
-  assert(info.commit_list==0 || tc_heuristic_recover==0);
-  /* if either is set, total_ha_2pc must be set too */
-  assert(info.dry_run);
-
-  if (total_ha_2pc <= 1)
-    return 0;
-
-  if (info.commit_list)
-    errmsg_printf(ERRMSG_LVL_INFO, _("Starting crash recovery..."));
-
-
-#ifndef WILL_BE_DELETED_LATER
-
-  /*
-    for now, only InnoDB supports 2pc. It means we can always safely
-    rollback all pending transactions, without risking inconsistent data
-  */
-
-  assert(total_ha_2pc == 2); // only InnoDB and binlog
-  tc_heuristic_recover= TC_HEURISTIC_RECOVER_ROLLBACK; // forcing ROLLBACK
-  info.dry_run=false;
-#endif
-
-
-  for (info.len= MAX_XID_LIST_SIZE ;
-       info.list==0 && info.len > MIN_XID_LIST_SIZE; info.len/=2)
-  {
-    info.list=(XID *)malloc(info.len*sizeof(XID));
-  }
-  if (!info.list)
-  {
-    errmsg_printf(ERRMSG_LVL_ERROR, ER(ER_OUTOFMEMORY), info.len*sizeof(XID));
-    return(1);
-  }
-
-  plugin_foreach(NULL, xarecover_storage_engine,
-                 DRIZZLE_STORAGE_ENGINE_PLUGIN, &info);
-
-  free((unsigned char*)info.list);
-  if (info.found_foreign_xids)
-    errmsg_printf(ERRMSG_LVL_WARN, _("Found %d prepared XA transactions"),
-                  info.found_foreign_xids);
-  if (info.dry_run && info.found_my_xids)
-  {
-    errmsg_printf(ERRMSG_LVL_ERROR,
-                  _("Found %d prepared transactions! It means that drizzled "
-                    "was not shut down properly last time and critical "
-                    "recovery information (last binlog or %s file) was "
-                    "manually deleted after a crash. You have to start "
-                    "drizzled with the --tc-heuristic-recover switch to "
-                    "commit or rollback pending transactions."),
-                    info.found_my_xids, opt_tc_log_file);
-    return(1);
-  }
-  if (info.commit_list)
-    errmsg_printf(ERRMSG_LVL_INFO, _("Crash recovery finished."));
-  return(0);
-}
+
 
 /**
   return the list of XID's to a client, the same way SHOW commands do.
@@ -1096,43 +872,6 @@
   return(0);
 }
 
-/**
-  @details
-  This function should be called when MySQL sends rows of a SELECT result set
-  or the EOF mark to the client. It releases a possible adaptive hash index
-  S-latch held by session in InnoDB and also releases a possible InnoDB query
-  FIFO ticket to enter InnoDB. To save CPU time, InnoDB allows a session to
-  keep them over several calls of the InnoDB handler interface when a join
-  is executed. But when we let the control to pass to the client they have
-  to be released because if the application program uses mysql_use_result(),
-  it may deadlock on the S-latch if the application on another connection
-  performs another SQL query. In MySQL-4.1 this is even more important because
-  there a connection can have several SELECT queries open at the same time.
-
-  @param session           the thread handle of the current connection
-
-  @return
-    always 0
-*/
-static bool release_temporary_latches(Session *session, st_plugin_int *plugin,
-                                      void *)
-{
-  StorageEngine *engine= plugin_data(plugin, StorageEngine *);
-
-  if (engine->is_enabled())
-    engine->release_temporary_latches(session);
-
-  return false;
-}
-
-
-int ha_release_temporary_latches(Session *session)
-{
-  plugin_foreach(session, release_temporary_latches, DRIZZLE_STORAGE_ENGINE_PLUGIN,
-                 NULL);
-
-  return 0;
-}
 
 int ha_rollback_to_savepoint(Session *session, SAVEPOINT *sv)
 {
@@ -1240,234 +979,8 @@
 }
 
 
-static bool snapshot_storage_engine(Session *session, st_plugin_int *plugin, void *arg)
-{
-  StorageEngine *engine= plugin_data(plugin, StorageEngine *);
-  if (engine->is_enabled())
-  {
-    engine->start_consistent_snapshot(session);
-    *((bool *)arg)= false;
-  }
-  return false;
-}
-
-int ha_start_consistent_snapshot(Session *session)
-{
-  bool warn= true;
-
-  plugin_foreach(session, snapshot_storage_engine, DRIZZLE_STORAGE_ENGINE_PLUGIN, &warn);
-
-  /*
-    Same idea as when one wants to CREATE TABLE in one engine which does not
-    exist:
-  */
-  if (warn)
-    push_warning(session, DRIZZLE_ERROR::WARN_LEVEL_WARN, ER_UNKNOWN_ERROR,
-                 "This Drizzle server does not support any "
-                 "consistent-read capable storage engine");
-  return 0;
-}
-
-
-static bool flush_storage_engine(Session *,
-                             st_plugin_int *plugin,
-                             void *)
-{
-  StorageEngine *engine= plugin_data(plugin, StorageEngine *);
-  if (engine->is_enabled() &&
-      engine->flush_logs())
-    return true;
-  return false;
-}
-
-
-bool ha_flush_logs(StorageEngine *engine)
-{
-  if (engine == NULL)
-  {
-    if (plugin_foreach(NULL, flush_storage_engine,
-                          DRIZZLE_STORAGE_ENGINE_PLUGIN, 0))
-      return true;
-  }
-  else
-  {
-    if ((!engine->is_enabled()) ||
-        (engine->flush_logs()))
-      return true;
-  }
-  return false;
-}
-
-static const char *check_lowercase_names(handler *file, const char *path,
-                                         char *tmp_path)
-{
-  if (lower_case_table_names != 2 || (file->ha_table_flags() & HA_FILE_BASED))
-    return path;
-
-  /* Ensure that table handler get path in lower case */
-  if (tmp_path != path)
-    strcpy(tmp_path, path);
-
-  /*
-    we only should turn into lowercase database/table part
-    so start the process after homedirectory
-  */
-  my_casedn_str(files_charset_info, tmp_path + drizzle_data_home_len);
-  return tmp_path;
-}
-
-
-/**
-  An interceptor to hijack the text of the error message without
-  setting an error in the thread. We need the text to present it
-  in the form of a warning to the user.
-*/
-
-struct Ha_delete_table_error_handler: public Internal_error_handler
-{
-public:
-  Ha_delete_table_error_handler() : Internal_error_handler() {}
-  virtual bool handle_error(uint32_t sql_errno,
-                            const char *message,
-                            DRIZZLE_ERROR::enum_warning_level level,
-                            Session *session);
-  char buff[DRIZZLE_ERRMSG_SIZE];
-};
-
-
-bool
-Ha_delete_table_error_handler::
-handle_error(uint32_t ,
-             const char *message,
-             DRIZZLE_ERROR::enum_warning_level ,
-             Session *)
-{
-  /* Grab the error message */
-  strncpy(buff, message, sizeof(buff)-1);
-  return true;
-}
-
-
-struct storage_engine_delete_table_args {
-  Session *session;
-  const char *path;
-  handler *file;
-  int error;
-};
-
-static bool deletetable_storage_engine(Session *,
-                                       st_plugin_int *plugin,
-                                       void *args)
-{
-  struct storage_engine_delete_table_args *dtargs= (struct storage_engine_delete_table_args *) args;
-
-  Session *session= dtargs->session;
-  const char *path= dtargs->path;
-
-  handler *file;
-  char tmp_path[FN_REFLEN];
-
-  if(dtargs->error!=ENOENT) /* already deleted table */
-    return false;
-
-  StorageEngine *engine= plugin_data(plugin, StorageEngine *);
-
-  if (!engine)
-    return false;
-
-  if (!engine->is_enabled())
-    return false;
-
-  if ((file= engine->create(NULL, session->mem_root)))
-    file->init();
-  else
-    return false;
-
-  path= check_lowercase_names(file, path, tmp_path);
-  int error= file->ha_delete_table(path);
-
-  if(error!=ENOENT)
-  {
-    dtargs->error= error;
-    if(dtargs->file)
-      delete dtargs->file;
-    dtargs->file= file;
-    return true;
-  }
-  else
-    delete file;
-
-  return false;
-}
-
-/**
-  This should return ENOENT if the file doesn't exists.
-  The .frm file will be deleted only if we return 0 or ENOENT
-*/
-int ha_delete_table(Session *session, const char *path,
-                    const char *db, const char *alias, bool generate_warning)
-{
-  TABLE_SHARE dummy_share;
-  Table dummy_table;
-
-  struct storage_engine_delete_table_args dtargs;
-  dtargs.error= ENOENT;
-  dtargs.session= session;
-  dtargs.path= path;
-  dtargs.file= NULL;
-
-  plugin_foreach(NULL, deletetable_storage_engine, DRIZZLE_STORAGE_ENGINE_PLUGIN,
-                 &dtargs);
-
-  memset(&dummy_table, 0, sizeof(dummy_table));
-  memset(&dummy_share, 0, sizeof(dummy_share));
-  dummy_table.s= &dummy_share;
-
-  if (dtargs.error && generate_warning)
-  {
-    /*
-      Because file->print_error() use my_error() to generate the error message
-      we use an internal error handler to intercept it and store the text
-      in a temporary buffer. Later the message will be presented to user
-      as a warning.
-    */
-    Ha_delete_table_error_handler ha_delete_table_error_handler;
-
-    /* Fill up strucutures that print_error may need */
-    dummy_share.path.str= (char*) path;
-    dummy_share.path.length= strlen(path);
-    dummy_share.db.str= (char*) db;
-    dummy_share.db.length= strlen(db);
-    dummy_share.table_name.str= (char*) alias;
-    dummy_share.table_name.length= strlen(alias);
-    dummy_table.alias= alias;
-
-    if(dtargs.file)
-    {
-      handler *file= dtargs.file;
-      file->change_table_ptr(&dummy_table, &dummy_share);
-
-      session->push_internal_handler(&ha_delete_table_error_handler);
-      file->print_error(dtargs.error, 0);
-
-      session->pop_internal_handler();
-    }
-    else
-      dtargs.error= -1; /* General form of fail. maybe bad FRM */
-
-    /*
-      XXX: should we convert *all* errors to warnings here?
-      What if the error is fatal?
-    */
-    push_warning(session, DRIZZLE_ERROR::WARN_LEVEL_ERROR, dtargs.error,
-                ha_delete_table_error_handler.buff);
-  }
-
-  if(dtargs.file)
-    delete dtargs.file;
-
-  return dtargs.error;
-}
+
+
 
 /****************************************************************************
 ** General handler functions
@@ -2825,47 +2338,6 @@
 ** Some general functions that isn't in the handler class
 ****************************************************************************/
 
-/**
-  Initiates table-file and calls appropriate database-creator.
-
-  @retval
-   0  ok
-  @retval
-   1  error
-*/
-int ha_create_table(Session *session, const char *path,
-                    const char *db, const char *table_name,
-                    HA_CREATE_INFO *create_info,
-		    bool update_create_info)
-{
-  int error= 1;
-  Table table;
-  char name_buff[FN_REFLEN];
-  const char *name;
-  TABLE_SHARE share;
-
-  init_tmp_table_share(session, &share, db, 0, table_name, path);
-  if (open_table_def(session, &share, 0) ||
-      open_table_from_share(session, &share, "", 0, (uint32_t) READ_ALL, 0, &table,
-                            OTM_CREATE))
-    goto err;
-
-  if (update_create_info)
-    table.updateCreateInfo(create_info);
-
-  name= check_lowercase_names(table.file, share.path.str, name_buff);
-
-  error= table.file->ha_create(name, &table, create_info);
-  table.closefrm(false);
-  if (error)
-  {
-    sprintf(name_buff,"%s.%s",db,table_name);
-    my_error(ER_CANT_CREATE_TABLE, MYF(ME_BELL+ME_WAITTANG), name_buff, error);
-  }
-err:
-  free_table_share(&share);
-  return(error != 0);
-}
 
 void st_ha_check_opt::init()
 {
@@ -2963,100 +2435,6 @@
   return 0;
 }
 
-/**
-  Call this function in order to give the handler the possiblity
-  to ask engine if there are any new tables that should be written to disk
-  or any dropped tables that need to be removed from disk
-*/
-struct st_find_files_args
-{
-  const char *db;
-  const char *path;
-  const char *wild;
-  bool dir;
-  List<LEX_STRING> *files;
-};
-
-/**
-  Ask handler if the table exists in engine.
-  @retval
-    HA_ERR_NO_SUCH_TABLE     Table does not exist
-  @retval
-    HA_ERR_TABLE_EXIST       Table exists
-  @retval
-    \#                  Error code
-*/
-struct st_table_exists_in_storage_engine_args
-{
-  const char *db;
-  const char *name;
-  int err;
-  StorageEngine* engine;
-};
-
-static bool table_exists_in_storage_engine(Session *session,
-                                           st_plugin_int *plugin,
-                                           void *arg)
-{
-  st_table_exists_in_storage_engine_args *vargs= (st_table_exists_in_storage_engine_args *)arg;
-  StorageEngine *engine= plugin_data(plugin, StorageEngine *);
-
-  int err= HA_ERR_NO_SUCH_TABLE;
-
-  if (engine->is_enabled())
-    err = engine->table_exists_in_engine(session, vargs->db, vargs->name);
-
-  vargs->err = err;
-  if (vargs->err == HA_ERR_TABLE_EXIST)
-  {
-    vargs->engine= engine;
-    return true;
-  }
-
-  return false;
-}
-
-int ha_table_exists_in_engine(Session* session,
-                              const char* db, const char* name,
-                              StorageEngine **engine)
-{
-  st_table_exists_in_storage_engine_args args= {db, name, HA_ERR_NO_SUCH_TABLE, NULL};
-  plugin_foreach(session, table_exists_in_storage_engine,
-                 DRIZZLE_STORAGE_ENGINE_PLUGIN, &args);
-
-  if(args.err==HA_ERR_NO_SUCH_TABLE)
-  {
-    /* Default way of knowing if a table exists. (checking .frm exists) */
-
-    char path[FN_REFLEN];
-    build_table_filename(path, sizeof(path),
-                         db, name, "", 0);
-    if (table_proto_exists(path)==EEXIST)
-      args.err= HA_ERR_TABLE_EXIST;
-    else
-      args.err= HA_ERR_NO_SUCH_TABLE;
-
-    if(args.err==HA_ERR_TABLE_EXIST)
-    {
-      drizzle::Table table;
-      build_table_filename(path, sizeof(path),
-                           db, name, ".dfe", 0);
-      if(drizzle_read_table_proto(path, &table)==0)
-      {
-        LEX_STRING engine_name= { (char*)table.engine().name().c_str(),
-                                 strlen(table.engine().name().c_str()) };
-        st_plugin_int *plugin= ha_resolve_by_name(session, &engine_name);
-        if(plugin)
-          args.engine= static_cast<StorageEngine *>(plugin->data);
-      }
-    }
-  }
-
-  if(engine)
-    *engine= args.engine;
-
-  return(args.err);
-}
 
 /**
   Calculate cost of 'index only' scan for given index and number of records
@@ -4071,75 +3449,6 @@
 }
 
 
-/**
-  Returns a list of all known extensions.
-
-    No mutexes, worst case race is a minor surplus memory allocation
-    We have to recreate the extension map if mysqld is restarted (for example
-    within libmysqld)
-
-  @retval
-    pointer		pointer to TYPELIB structure
-*/
-static bool exts_handlerton(Session *,
-                            st_plugin_int *plugin,
-                            void *arg)
-{
-  List<char> *found_exts= (List<char> *) arg;
-  StorageEngine *engine= plugin_data(plugin, StorageEngine *);
-  handler *file;
-  if (engine->is_enabled() &&
-      (file= engine->create((TABLE_SHARE*) 0, current_session->mem_root)))
-  {
-    List_iterator_fast<char> it(*found_exts);
-    const char **ext, *old_ext;
-
-    for (ext= file->bas_ext(); *ext; ext++)
-    {
-      while ((old_ext= it++))
-      {
-        if (!strcmp(old_ext, *ext))
-	  break;
-      }
-      if (!old_ext)
-        found_exts->push_back((char *) *ext);
-
-      it.rewind();
-    }
-    delete file;
-  }
-  return false;
-}
-
-TYPELIB *ha_known_exts(void)
-{
-  if (!known_extensions.type_names || mysys_usage_id != known_extensions_id)
-  {
-    List<char> found_exts;
-    const char **ext, *old_ext;
-
-    known_extensions_id= mysys_usage_id;
-
-    plugin_foreach(NULL, exts_handlerton,
-                   DRIZZLE_STORAGE_ENGINE_PLUGIN, &found_exts);
-
-    ext= (const char **) malloc(sizeof(char *)*
-                                (found_exts.elements+1));
-                              
-
-    assert(ext != 0);
-    known_extensions.count= found_exts.elements;
-    known_extensions.type_names= ext;
-
-    List_iterator_fast<char> it(found_exts);
-    while ((old_ext= it++))
-      *ext++= old_ext;
-    *ext= 0;
-  }
-  return &known_extensions;
-}
-
-
 static bool stat_print(Session *session, const char *type, uint32_t type_len,
                        const char *file, uint32_t file_len,
                        const char *status, uint32_t status_len)

=== modified file 'drizzled/handler.h'
--- drizzled/handler.h	2009-04-07 06:07:18 +0000
+++ drizzled/handler.h	2009-04-09 05:35:58 +0000
@@ -1108,7 +1108,6 @@
 int storage_engine_initializer(st_plugin_int *plugin);
 int storage_engine_finalizer(st_plugin_int *plugin);
 
-TYPELIB *ha_known_exts(void);
 void ha_close_connection(Session* session);
 bool ha_flush_logs(StorageEngine *db_type);
 void ha_drop_database(char* path);

=== modified file 'drizzled/item/field.cc'
--- drizzled/item/field.cc	2009-04-08 23:01:10 +0000
+++ drizzled/item/field.cc	2009-04-09 23:30:44 +0000
@@ -728,6 +728,18 @@
   return 1;
 }
 
+/*
+ *
+ */
+static bool test_and_set_bit(bitset<MAX_FIELDS> *bitmap, uint32_t pos)
+{
+  bool ret= false;
+  if (bitmap->test(pos))
+    ret= true;
+  bitmap->set(pos);
+  return ret;
+}
+
 
 /**
   Resolve the name of a column reference.
@@ -914,10 +926,8 @@
       current_bitmap= table->write_set;
       other_bitmap=   table->read_set;
     }
-    /* TODO: is this equivalent to bitmap test and set? don't think so... */
-    if (!current_bitmap->test(field->field_index))
+    if (!test_and_set_bit(current_bitmap, field->field_index))
     {
-      current_bitmap->set(field->field_index);
       if (!other_bitmap->test(field->field_index))
       {
         /* First usage of column */
@@ -927,7 +937,6 @@
         /* purecov: end */
       }
     }
-    current_bitmap->set(field->field_index);
   }
   fixed= 1;
 mark_non_agg_field:

=== modified file 'drizzled/opt_range.cc'
--- drizzled/opt_range.cc	2009-04-09 02:55:10 +0000
+++ drizzled/opt_range.cc	2009-04-09 23:30:44 +0000
@@ -3379,6 +3379,24 @@
   return(trp);
 }
 
+/*
+ * Helper method to find the position of the first bit in the
+ * given bitset that is set to 1.
+ * If no bit is set in the given bitset, return MY_BIT_NONE.
+ */
+static uint32_t get_first_bit_on_pos(bitset<MAX_FIELDS> &bitmap)
+{
+  uint32_t first_bit_on= MY_BIT_NONE;
+  for (int idx= 0; idx < MAX_FIELDS; idx++)
+  {
+    if (bitmap.test(idx))
+    {
+      first_bit_on= idx;
+      break;
+    }
+  } 
+  return first_bit_on;
+}
 
 /*
   Get best covering ROR-intersection.
@@ -3457,16 +3475,7 @@
       (*scan)->covered_fields &= covered_fields->flip();
       covered_fields->flip();
       (*scan)->used_fields_covered= (*scan)->covered_fields.count();
-      uint32_t first_bit_on= MY_BIT_NONE;
-      for (int idx= 0; idx < MAX_FIELDS; idx++)
-      {
-        if ((*scan)->covered_fields.test(idx))
-        {
-          first_bit_on= idx;
-          break;
-        }
-      }
-      (*scan)->first_uncovered_field= first_bit_on;
+      (*scan)->first_uncovered_field= get_first_bit_on_pos((*scan)->covered_fields);
     }
 
     my_qsort(ror_scan_mark, ror_scans_end-ror_scan_mark, sizeof(ROR_SCAN_INFO*),

=== modified file 'drizzled/plugin/protocol.h'
--- drizzled/plugin/protocol.h	2009-04-08 00:00:15 +0000
+++ drizzled/plugin/protocol.h	2009-04-09 07:39:41 +0000
@@ -64,7 +64,8 @@
   virtual void sendOK()= 0;
   virtual void sendEOF()= 0;
   virtual void sendError(uint32_t sql_errno, const char *err)=0;
-  virtual void close(void) {};
+  virtual void close()= 0;
+  virtual void forceClose()= 0;
   virtual void prepareForResend()= 0;
   virtual void free()= 0;
   virtual bool write()= 0;

=== modified file 'drizzled/plugin/storage_engine.cc'
--- drizzled/plugin/storage_engine.cc	2009-04-08 03:20:31 +0000
+++ drizzled/plugin/storage_engine.cc	2009-04-09 04:25:23 +0000
@@ -25,23 +25,26 @@
 #include <drizzled/session.h>
 #include <drizzled/error.h>
 #include <drizzled/gettext.h>
-#include <map>
+#include <drizzled/registry.h>
+#include <drizzled/unireg.h>
+#include <drizzled/data_home.h>
 #include <string>
 
 #include CSTDINT_H
 
 using namespace std;
 
-map<string, StorageEngine *> all_engines;
-
-st_plugin_int *engine2plugin[MAX_HA];
-
-static const LEX_STRING sys_table_aliases[]=
-{
-  { C_STRING_WITH_LEN("INNOBASE") },  { C_STRING_WITH_LEN("INNODB") },
-  { C_STRING_WITH_LEN("HEAP") },      { C_STRING_WITH_LEN("MEMORY") },
-  {NULL, 0}
-};
+drizzled::Registry<StorageEngine *> all_engines;
+
+static void add_storage_engine(StorageEngine *engine)
+{
+  all_engines.add(engine);
+}
+
+static void remove_storage_engine(StorageEngine *engine)
+{
+  all_engines.remove(engine);
+}
 
 StorageEngine::StorageEngine(const std::string name_arg,
                              const std::bitset<HTON_BIT_SIZE> &flags_arg,
@@ -75,13 +78,6 @@
   return HA_ERR_NO_SUCH_TABLE;
 }
 
-static st_plugin_int *ha_default_plugin(Session *session)
-{
-  if (session->variables.table_plugin)
-    return session->variables.table_plugin;
-  return global_system_variables.table_plugin;
-}
-
 
 /**
   Return the default storage engine StorageEngine for thread
@@ -94,11 +90,9 @@
 */
 StorageEngine *ha_default_storage_engine(Session *session)
 {
-  st_plugin_int *plugin= ha_default_plugin(session);
-  assert(plugin);
-  StorageEngine *engine= static_cast<StorageEngine *>(plugin->data);
-  assert(engine);
-  return engine;
+  if (session->variables.storage_engine)
+    return session->variables.storage_engine;
+  return global_system_variables.storage_engine;
 }
 
 
@@ -111,52 +105,21 @@
   @return
     pointer to storage engine plugin handle
 */
-st_plugin_int *ha_resolve_by_name(Session *session, const LEX_STRING *name)
-{
-  const LEX_STRING *table_alias;
-  st_plugin_int *plugin;
-
-redo:
-  /* my_strnncoll is a macro and gcc doesn't do early expansion of macro */
-  if (session && !my_charset_utf8_general_ci.coll->strnncoll(&my_charset_utf8_general_ci,
-                           (const unsigned char *)name->str, name->length,
-                           (const unsigned char *)STRING_WITH_LEN("DEFAULT"), 0))
-    return ha_default_plugin(session);
-
-  if ((plugin= plugin_lock_by_name(name, DRIZZLE_STORAGE_ENGINE_PLUGIN)))
-  {
-    StorageEngine *engine= static_cast<StorageEngine *>(plugin->data);
-    if (engine->is_user_selectable())
-      return plugin;
-  }
-
-  /*
-    We check for the historical aliases.
-  */
-  for (table_alias= sys_table_aliases; table_alias->str; table_alias+= 2)
-  {
-    if (!my_strnncoll(&my_charset_utf8_general_ci,
-                      (const unsigned char *)name->str, name->length,
-                      (const unsigned char *)table_alias->str,
-                      table_alias->length))
-    {
-      name= table_alias + 1;
-      goto redo;
-    }
-  }
-
-  return NULL;
-}
-
-
-st_plugin_int *ha_lock_engine(Session *, StorageEngine *engine)
-{
-  if (engine)
-  {
-    st_plugin_int *plugin= engine2plugin[engine->slot];
-
-    return plugin;
-  }
+StorageEngine *ha_resolve_by_name(Session *session, const LEX_STRING *name)
+{
+
+  string find_str(name->str, name->length);
+  transform(find_str.begin(), find_str.end(),
+            find_str.begin(), ::tolower);
+  string default_str("default");
+  if (find_str == default_str)
+    return ha_default_storage_engine(session);
+    
+
+  StorageEngine *engine= all_engines.find(find_str);
+
+  if (engine && engine->is_user_selectable())
+    return engine;
 
   return NULL;
 }
@@ -181,12 +144,549 @@
   return(get_new_handler(share, alloc, ha_default_storage_engine(current_session)));
 }
 
+class StorageEngineCloseConnection
+  : public unary_function<StorageEngine *, void>
+{
+  Session *session;
+public:
+  StorageEngineCloseConnection(Session *session_arg) : session(session_arg) {}
+  /*
+    there's no need to rollback here as all transactions must
+    be rolled back already
+  */
+  inline result_type operator() (argument_type engine)
+  {
+    if (engine->is_enabled() && 
+      session_get_ha_data(session, engine))
+    engine->close_connection(session);
+  }
+};
+
+/**
+  @note
+    don't bother to rollback here, it's done already
+*/
+void ha_close_connection(Session* session)
+{
+  for_each(all_engines.begin(), all_engines.end(),
+           StorageEngineCloseConnection(session));
+}
+
+void ha_drop_database(char* path)
+{
+  for_each(all_engines.begin(), all_engines.end(),
+           bind2nd(mem_fun(&StorageEngine::drop_database),path));
+}
+
+int ha_commit_or_rollback_by_xid(XID *xid, bool commit)
+{
+  vector<int> results;
+  
+  if (commit)
+    transform(all_engines.begin(), all_engines.end(), results.begin(),
+              bind2nd(mem_fun(&StorageEngine::commit_by_xid),xid));
+  else
+    transform(all_engines.begin(), all_engines.end(), results.begin(),
+              bind2nd(mem_fun(&StorageEngine::rollback_by_xid),xid));
+
+  if (find_if(results.begin(), results.end(), bind2nd(equal_to<int>(),0))
+         == results.end())
+    return 1;
+  return 0;
+}
+
+
+/**
+  @details
+  This function should be called when MySQL sends rows of a SELECT result set
+  or the EOF mark to the client. It releases a possible adaptive hash index
+  S-latch held by session in InnoDB and also releases a possible InnoDB query
+  FIFO ticket to enter InnoDB. To save CPU time, InnoDB allows a session to
+  keep them over several calls of the InnoDB handler interface when a join
+  is executed. But when we let the control to pass to the client they have
+  to be released because if the application program uses mysql_use_result(),
+  it may deadlock on the S-latch if the application on another connection
+  performs another SQL query. In MySQL-4.1 this is even more important because
+  there a connection can have several SELECT queries open at the same time.
+
+  @param session           the thread handle of the current connection
+
+  @return
+    always 0
+*/
+int ha_release_temporary_latches(Session *session)
+{
+  for_each(all_engines.begin(), all_engines.end(),
+           bind2nd(mem_fun(&StorageEngine::release_temporary_latches),session));
+  return 0;
+}
+
+
+bool ha_flush_logs(StorageEngine *engine)
+{
+  if (engine == NULL)
+  {
+    if (find_if(all_engines.begin(), all_engines.end(),
+            mem_fun(&StorageEngine::flush_logs))
+          != all_engines.begin())
+      return true;
+  }
+  else
+  {
+    if ((!engine->is_enabled()) ||
+        (engine->flush_logs()))
+      return true;
+  }
+  return false;
+}
+
+/**
+  recover() step of xa.
+
+  @note
+    there are three modes of operation:
+    - automatic recover after a crash
+    in this case commit_list != 0, tc_heuristic_recover==0
+    all xids from commit_list are committed, others are rolled back
+    - manual (heuristic) recover
+    in this case commit_list==0, tc_heuristic_recover != 0
+    DBA has explicitly specified that all prepared transactions should
+    be committed (or rolled back).
+    - no recovery (MySQL did not detect a crash)
+    in this case commit_list==0, tc_heuristic_recover == 0
+    there should be no prepared transactions in this case.
+*/
+class XARecover : unary_function<StorageEngine *, void>
+{
+  int trans_len, found_foreign_xids, found_my_xids;
+  bool result;
+  XID *trans_list;
+  HASH *commit_list;
+  bool dry_run;
+public:
+  XARecover(XID *trans_list_arg, int trans_len_arg,
+            HASH *commit_list_arg, bool dry_run_arg) 
+    : trans_len(trans_len_arg), found_foreign_xids(0), found_my_xids(0),
+      trans_list(trans_list_arg), commit_list(commit_list_arg),
+      dry_run(dry_run_arg)
+  {}
+  
+  int getForeignXIDs()
+  {
+    return found_foreign_xids; 
+  }
+
+  int getMyXIDs()
+  {
+    return found_my_xids; 
+  }
+
+  result_type operator() (argument_type engine)
+  {
+  
+    int got;
+  
+    if (engine->is_enabled())
+    {
+      while ((got= engine->recover(trans_list, trans_len)) > 0 )
+      {
+        errmsg_printf(ERRMSG_LVL_INFO,
+                      _("Found %d prepared transaction(s) in %s"),
+                      got, engine->getName().c_str());
+        for (int i=0; i < got; i ++)
+        {
+          my_xid x=trans_list[i].get_my_xid();
+          if (!x) // not "mine" - that is generated by external TM
+          {
+            xid_cache_insert(trans_list+i, XA_PREPARED);
+            found_foreign_xids++;
+            continue;
+          }
+          if (dry_run)
+          {
+            found_my_xids++;
+            continue;
+          }
+          // recovery mode
+          if (commit_list ?
+              hash_search(commit_list, (unsigned char *)&x, sizeof(x)) != 0 :
+              tc_heuristic_recover == TC_HEURISTIC_RECOVER_COMMIT)
+          {
+            engine->commit_by_xid(trans_list+i);
+          }
+          else
+          {
+            engine->rollback_by_xid(trans_list+i);
+          }
+        }
+        if (got < trans_len)
+          break;
+      }
+    }
+  }
+
+};
+
+int ha_recover(HASH *commit_list)
+{
+  XID *trans_list= NULL;
+  int trans_len= 0;
+
+  bool dry_run= (commit_list==0 && tc_heuristic_recover==0);
+
+  /* commit_list and tc_heuristic_recover cannot be set both */
+  assert(commit_list==0 || tc_heuristic_recover==0);
+
+  /* if either is set, total_ha_2pc must be set too */
+  if (total_ha_2pc <= 1)
+    return 0;
+
+
+#ifndef WILL_BE_DELETED_LATER
+
+  /*
+    for now, only InnoDB supports 2pc. It means we can always safely
+    rollback all pending transactions, without risking inconsistent data
+  */
+
+  assert(total_ha_2pc == 2); // only InnoDB and binlog
+  tc_heuristic_recover= TC_HEURISTIC_RECOVER_ROLLBACK; // forcing ROLLBACK
+  dry_run=false;
+#endif
+  for (trans_len= MAX_XID_LIST_SIZE ;
+       trans_list==0 && trans_len > MIN_XID_LIST_SIZE; trans_len/=2)
+  {
+    trans_list=(XID *)malloc(trans_len*sizeof(XID));
+  }
+  if (!trans_list)
+  {
+    errmsg_printf(ERRMSG_LVL_ERROR, ER(ER_OUTOFMEMORY), trans_len*sizeof(XID));
+    return(1);
+  }
+
+  if (commit_list)
+    errmsg_printf(ERRMSG_LVL_INFO, _("Starting crash recovery..."));
+
+
+  XARecover recover_func(trans_list, trans_len, commit_list, dry_run);
+  for_each(all_engines.begin(), all_engines.end(), recover_func);
+  free(trans_list);
+ 
+  if (recover_func.getForeignXIDs())
+    errmsg_printf(ERRMSG_LVL_WARN,
+                  _("Found %d prepared XA transactions"),
+                  recover_func.getForeignXIDs());
+  if (dry_run && recover_func.getMyXIDs())
+  {
+    errmsg_printf(ERRMSG_LVL_ERROR,
+                  _("Found %d prepared transactions! It means that drizzled "
+                    "was not shut down properly last time and critical "
+                    "recovery information (last binlog or %s file) was "
+                    "manually deleted after a crash. You have to start "
+                    "drizzled with the --tc-heuristic-recover switch to "
+                    "commit or rollback pending transactions."),
+                    recover_func.getMyXIDs(), opt_tc_log_file);
+    return(1);
+  }
+  if (commit_list)
+    errmsg_printf(ERRMSG_LVL_INFO, _("Crash recovery finished."));
+  return(0);
+}
+
+int ha_start_consistent_snapshot(Session *session)
+{
+  for_each(all_engines.begin(), all_engines.end(),
+           bind2nd(mem_fun(&StorageEngine::start_consistent_snapshot),session));
+  return 0;
+}
+
+/**
+  Ask handler if the table exists in engine.
+  @retval
+    HA_ERR_NO_SUCH_TABLE     Table does not exist
+  @retval
+    HA_ERR_TABLE_EXIST       Table exists
+  @retval
+    \#                  Error code
+*/
+
+class TableExistsInStorageEngine: public unary_function<StorageEngine *,bool>
+{
+  Session *session;
+  const char *db;
+  const char *name;
+public:
+  TableExistsInStorageEngine(Session *session_arg,
+                             const char *db_arg, const char *name_arg)
+    :session(session_arg), db(db_arg), name(name_arg) {}
+  result_type operator() (argument_type engine)
+  {
+    int ret= engine->table_exists_in_engine(session, db, name);
+    return ret == HA_ERR_TABLE_EXIST;
+  } 
+};
+
+/**
+  Call this function in order to give the handler the possiblity
+  to ask engine if there are any new tables that should be written to disk
+  or any dropped tables that need to be removed from disk
+*/
+int ha_table_exists_in_engine(Session* session,
+                              const char* db, const char* name,
+                              StorageEngine **engine_arg)
+{
+  StorageEngine *engine= NULL;
+
+  drizzled::Registry<StorageEngine *>::iterator iter=
+    find_if(all_engines.begin(), all_engines.end(),
+            TableExistsInStorageEngine(session, db, name));
+  if (iter != all_engines.end()) 
+  {
+    engine= *iter;
+  }
+  else
+  {
+    /* Default way of knowing if a table exists. (checking .frm exists) */
+
+    char path[FN_REFLEN];
+    build_table_filename(path, sizeof(path),
+                         db, name, "", 0);
+    if (table_proto_exists(path)==EEXIST)
+    {
+      drizzle::Table table;
+      build_table_filename(path, sizeof(path),
+                           db, name, ".dfe", 0);
+      if(drizzle_read_table_proto(path, &table)==0)
+      {
+        LEX_STRING engine_name= { (char*)table.engine().name().c_str(),
+                                 strlen(table.engine().name().c_str()) };
+        engine= ha_resolve_by_name(session, &engine_name);
+      }
+    }
+  }
+
+  if(engine_arg)
+    *engine_arg= engine;
+
+  if (engine == NULL)
+    return HA_ERR_NO_SUCH_TABLE;
+  return HA_ERR_TABLE_EXIST;
+}
+
+
+static const char *check_lowercase_names(handler *file, const char *path,
+                                         char *tmp_path)
+{
+  if (lower_case_table_names != 2 || (file->ha_table_flags() & HA_FILE_BASED))
+    return path;
+
+  /* Ensure that table handler get path in lower case */
+  if (tmp_path != path)
+    strcpy(tmp_path, path);
+
+  /*
+    we only should turn into lowercase database/table part
+    so start the process after homedirectory
+  */
+  my_casedn_str(files_charset_info, tmp_path + drizzle_data_home_len);
+  return tmp_path;
+}
+
+/**
+  An interceptor to hijack the text of the error message without
+  setting an error in the thread. We need the text to present it
+  in the form of a warning to the user.
+*/
+
+class Ha_delete_table_error_handler: public Internal_error_handler
+{
+public:
+  Ha_delete_table_error_handler() : Internal_error_handler() {}
+  virtual bool handle_error(uint32_t sql_errno,
+                            const char *message,
+                            DRIZZLE_ERROR::enum_warning_level level,
+                            Session *session);
+  char buff[DRIZZLE_ERRMSG_SIZE];
+};
+
+
+bool
+Ha_delete_table_error_handler::
+handle_error(uint32_t ,
+             const char *message,
+             DRIZZLE_ERROR::enum_warning_level ,
+             Session *)
+{
+  /* Grab the error message */
+  strncpy(buff, message, sizeof(buff)-1);
+  return true;
+}
+
+
+class DeleteTableStorageEngine
+  : public unary_function<StorageEngine *, void>
+{
+  Session *session;
+  const char *path;
+  handler **file;
+  int *dt_error;
+public:
+  DeleteTableStorageEngine(Session *session_arg, const char *path_arg,
+                           handler **file_arg, int *error_arg)
+    : session(session_arg), path(path_arg), file(file_arg), dt_error(error_arg) {}
+
+  result_type operator() (argument_type engine)
+  {
+
+    handler *tmp_file;
+    char tmp_path[FN_REFLEN];
+
+    if(*dt_error!=ENOENT) /* already deleted table */
+      return;
+
+    if (!engine)
+      return;
+
+    if (!engine->is_enabled())
+      return;
+
+    if ((tmp_file= engine->create(NULL, session->mem_root)))
+      tmp_file->init();
+    else
+      return;
+
+    path= check_lowercase_names(tmp_file, path, tmp_path);
+    int tmp_error= tmp_file->ha_delete_table(path);
+
+    if(tmp_error!=ENOENT)
+    {
+      *dt_error= tmp_error;
+      if(*file)
+        delete *file;
+      *file= tmp_file;
+      return;
+    }
+    else
+      delete tmp_file;
+    
+    return;
+  }
+};
+
+/**
+  This should return ENOENT if the file doesn't exists.
+  The .frm file will be deleted only if we return 0 or ENOENT
+*/
+int ha_delete_table(Session *session, const char *path,
+                    const char *db, const char *alias, bool generate_warning)
+{
+  TABLE_SHARE dummy_share;
+  Table dummy_table;
+  memset(&dummy_table, 0, sizeof(dummy_table));
+  memset(&dummy_share, 0, sizeof(dummy_share));
+
+  dummy_table.s= &dummy_share;
+
+  int error= ENOENT;
+  handler *file= NULL;
+
+  for_each(all_engines.begin(), all_engines.end(),
+           DeleteTableStorageEngine(session, path, &file, &error));
+
+  if (error && generate_warning)
+  {
+    /*
+      Because file->print_error() use my_error() to generate the error message
+      we use an internal error handler to intercept it and store the text
+      in a temporary buffer. Later the message will be presented to user
+      as a warning.
+    */
+    Ha_delete_table_error_handler ha_delete_table_error_handler;
+
+    /* Fill up strucutures that print_error may need */
+    dummy_share.path.str= (char*) path;
+    dummy_share.path.length= strlen(path);
+    dummy_share.db.str= (char*) db;
+    dummy_share.db.length= strlen(db);
+    dummy_share.table_name.str= (char*) alias;
+    dummy_share.table_name.length= strlen(alias);
+    dummy_table.alias= alias;
+
+
+    if(file != NULL)
+    {
+      file->change_table_ptr(&dummy_table, &dummy_share);
+
+      session->push_internal_handler(&ha_delete_table_error_handler);
+      file->print_error(error, 0);
+
+      session->pop_internal_handler();
+    }
+    else
+      error= -1; /* General form of fail. maybe bad FRM */
+
+    /*
+      XXX: should we convert *all* errors to warnings here?
+      What if the error is fatal?
+    */
+    push_warning(session, DRIZZLE_ERROR::WARN_LEVEL_ERROR, error,
+                 ha_delete_table_error_handler.buff);
+  }
+
+  if(file)
+    delete file;
+
+  return error;
+}
+
+/**
+  Initiates table-file and calls appropriate database-creator.
+
+  @retval
+   0  ok
+  @retval
+   1  error
+*/
+int ha_create_table(Session *session, const char *path,
+                    const char *db, const char *table_name,
+                    HA_CREATE_INFO *create_info,
+                    bool update_create_info)
+{
+  int error= 1;
+  Table table;
+  char name_buff[FN_REFLEN];
+  const char *name;
+  TABLE_SHARE share;
+
+  init_tmp_table_share(session, &share, db, 0, table_name, path);
+  if (open_table_def(session, &share, 0) ||
+      open_table_from_share(session, &share, "", 0, (uint32_t) READ_ALL, 0, &table,
+                            OTM_CREATE))
+    goto err;
+
+  if (update_create_info)
+    table.updateCreateInfo(create_info);
+
+  name= check_lowercase_names(table.file, share.path.str, name_buff);
+
+  error= table.file->ha_create(name, &table, create_info);
+  table.closefrm(false);
+  if (error)
+  {
+    sprintf(name_buff,"%s.%s",db,table_name);
+    my_error(ER_CANT_CREATE_TABLE, MYF(ME_BELL+ME_WAITTANG), name_buff, error);
+  }
+err:
+  free_table_share(&share);
+  return(error != 0);
+}
+
 
 int storage_engine_finalizer(st_plugin_int *plugin)
 {
   StorageEngine *engine= static_cast<StorageEngine *>(plugin->data);
 
-  all_engines.erase(engine->getName());
+  remove_storage_engine(engine);
 
   if (engine && plugin->plugin->deinit)
     (void)plugin->plugin->deinit(engine);
@@ -197,8 +697,7 @@
 
 int storage_engine_initializer(st_plugin_int *plugin)
 {
-  StorageEngine *engine;
-
+  StorageEngine *engine= NULL;
 
   if (plugin->plugin->init)
   {
@@ -211,23 +710,11 @@
     }
   }
 
-  if (engine->is_enabled())
-    engine2plugin[engine->slot]= plugin;
-
-  /*
-    This is entirely for legacy. We will create a new "disk based" engine and a
-    "memory" engine which will be configurable longterm. We should be able to
-    remove partition and myisammrg.
-  */
-  if (strcmp(plugin->plugin->name, "MEMORY") == 0)
-    heap_engine= engine;
-
-  if (strcmp(plugin->plugin->name, "MyISAM") == 0)
-    myisam_engine= engine;
+  if (engine != NULL)
+    add_storage_engine(engine);
 
   plugin->data= engine;
   plugin->isInited= true;
-  all_engines[engine->getName()]= engine;
 
   return 0;
 }

=== modified file 'drizzled/plugin/storage_engine.h'
--- drizzled/plugin/storage_engine.h	2009-04-08 03:20:31 +0000
+++ drizzled/plugin/storage_engine.h	2009-04-08 09:42:38 +0000
@@ -26,6 +26,7 @@
 
 #include <bitset>
 #include <string>
+#include <vector>
 
 class TableList;
 class Session;
@@ -95,6 +96,7 @@
   */
   size_t savepoint_offset;
   size_t orig_savepoint_offset;
+  std::vector<std::string> aliases;
 
 protected:
 
@@ -128,6 +130,16 @@
 
   virtual ~StorageEngine();
 
+  const std::vector<std::string>& getAliases()
+  {
+    return aliases;
+  }
+
+  void addAlias(std::string alias)
+  {
+    aliases.push_back(alias);
+  }
+
   bool has_2pc()
   {
     return two_phase_commit;
@@ -233,8 +245,7 @@
 
 /* lookups */
 StorageEngine *ha_default_storage_engine(Session *session);
-st_plugin_int *ha_resolve_by_name(Session *session, const LEX_STRING *name);
-st_plugin_int *ha_lock_engine(Session *session, StorageEngine *engine);
+StorageEngine *ha_resolve_by_name(Session *session, const LEX_STRING *name);
 handler *get_new_handler(TABLE_SHARE *share, MEM_ROOT *alloc,
                          StorageEngine *db_type);
 const std::string ha_resolve_storage_engine_name(const StorageEngine *db_type);

=== added file 'drizzled/registry.h'
--- drizzled/registry.h	1970-01-01 00:00:00 +0000
+++ drizzled/registry.h	2009-04-08 10:49:06 +0000
@@ -0,0 +1,165 @@
+/* -*- mode: c++; c-basic-offset: 2; indent-tabs-mode: nil; -*-
+ *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
+ *
+ *  Copyright (C) 2008 Sun Microsystems
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; version 2 of the License.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+ */
+
+#ifndef DRIZZLED_REGISTRY_H
+#define DRIZZLED_REGISTRY_H
+
+#include <map>
+#include <set>
+#include <string>
+
+namespace drizzled {
+
+template<class T>
+class Registry
+{
+  std::map<std::string, T> item_map;
+  std::set<T> item_set;
+
+  bool addItemEntry(std::string name, T item)
+  {
+    if (item_map.count(name) == 0)
+    {
+      item_map[name]= item;
+      return false;
+    }
+    return true;
+  }
+
+  bool addItem(std::string name, T item)
+  {
+
+    /* First, add with no transform */
+    if (addItemEntry(name, item))
+      return true;
+
+    /* Transform to lower, then add */ 
+    transform(name.begin(), name.end(),
+              name.begin(), ::tolower);
+    /* Ignore failures here - the original name could be all lower */
+    addItemEntry(name, item);
+
+    return false;
+  }
+
+  void removeItem(std::string name)
+  {
+
+    /* First, remove with no transform */
+    item_map.erase(name);
+
+    /* Transform to lower, then remove */ 
+    transform(name.begin(), name.end(),
+              name.begin(), ::tolower);
+    item_map.erase(name);
+  }
+
+public:
+
+  typedef typename std::set<T>::const_iterator const_iterator;
+  typedef typename std::set<T>::iterator iterator;
+
+  T find(const char *name, size_t length)
+  {
+    std::string find_str(name, length);
+    return find(find_str);
+  }
+
+  T find(std::string name)
+  {
+
+    typename std::map<std::string, T>::iterator find_iter;
+    find_iter=  item_map.find(name);
+    if (find_iter != item_map.end())
+      return (*find_iter).second;
+    
+    transform(name.begin(), name.end(),
+              name.begin(), ::tolower);
+    find_iter=  item_map.find(name);
+    if (find_iter != item_map.end())
+      return (*find_iter).second;
+
+    return NULL;
+  }
+
+  /**
+   * True == failure
+   */
+  bool add(T item)
+  {
+    bool failed= false;
+
+    if (item_set.insert(item).second == false)
+      return true;
+
+    if (addItem(item->getName(), item))
+      failed= true;
+
+    const std::vector<std::string>& aliases= item->getAliases();
+    if (!(failed) && (aliases.size() > 0))
+    {
+      typename std::vector<std::string>::const_iterator iter= aliases.begin();
+      while (iter != aliases.end())
+      {
+        if(addItem(*iter, item))
+          failed= true;
+        ++iter;
+      }
+    }
+   
+    if (failed == true)
+      remove(item);
+    return failed; 
+  }
+
+  /**
+   * Remove an item from the registry. We don't care about failure
+   */
+  void remove(T item)
+  {
+    removeItem(item->getName());
+
+    const std::vector<std::string>& aliases= item->getAliases();
+    if (aliases.size() > 0)
+    {
+      std::vector<std::string>::const_iterator iter= aliases.begin();
+      while (iter != aliases.end())
+      {
+        removeItem(*iter);
+        ++iter;
+      }
+    }
+  }
+
+  const_iterator begin()
+  {
+    return item_set.begin();
+  }
+
+  const_iterator end()
+  {
+    return item_set.end();
+  }
+
+};
+
+} /* namespace drizzled */
+
+#endif /* DRIZZLED_REGISTRY_H */
+

=== modified file 'drizzled/session.h'
--- drizzled/session.h	2009-04-09 01:11:00 +0000
+++ drizzled/session.h	2009-04-09 05:35:58 +0000
@@ -185,7 +185,7 @@
 
   bool old_alter_table;
 
-  st_plugin_int *table_plugin;
+  StorageEngine *storage_engine;
 
   /* Only charset part of these variables is sensible */
   const CHARSET_INFO  *character_set_filesystem;

=== modified file 'drizzled/set_var.cc'
--- drizzled/set_var.cc	2009-04-09 01:11:00 +0000
+++ drizzled/set_var.cc	2009-04-09 05:35:58 +0000
@@ -277,7 +277,7 @@
                                                                &SV::optimizer_switch);
 
 static sys_var_session_storage_engine sys_storage_engine(&vars, "storage_engine",
-				       &SV::table_plugin);
+				       &SV::storage_engine);
 static sys_var_const_str	sys_system_time_zone(&vars, "system_time_zone",
                                              system_time_zone);
 static sys_var_uint64_t_ptr	sys_table_def_size(&vars, "table_definition_cache",
@@ -2287,7 +2287,7 @@
   const char *value;
   String str(buff, sizeof(buff), &my_charset_utf8_general_ci), *res;
 
-  var->save_result.plugin= NULL;
+  var->save_result.storage_engine= NULL;
   if (var->value->result_type() == STRING_RESULT)
   {
     LEX_STRING engine_name;
@@ -2295,8 +2295,9 @@
     if (!(res=var->value->val_str(&str)) ||
         !(engine_name.str= (char *)res->ptr()) ||
         !(engine_name.length= res->length()) ||
-	!(var->save_result.plugin= ha_resolve_by_name(session, &engine_name)) ||
-        !(engine= static_cast<StorageEngine *>(var->save_result.plugin->data)))
+	      !(var->save_result.storage_engine=
+            ha_resolve_by_name(session, &engine_name)) ||
+        !(engine= var->save_result.storage_engine))
     {
       value= res ? res->c_ptr() : "NULL";
       goto err;
@@ -2316,12 +2317,10 @@
                                                          const LEX_STRING *)
 {
   unsigned char* result;
-  StorageEngine *engine;
   string engine_name;
-  st_plugin_int *plugin= session->variables.*offset;
+  StorageEngine *engine= session->variables.*offset;
   if (type == OPT_GLOBAL)
-    plugin= global_system_variables.*offset;
-  engine= static_cast<StorageEngine*>(plugin->data);
+    engine= global_system_variables.*offset;
   engine_name= engine->getName();
   result= (unsigned char *) session->strmake(engine_name.c_str(),
                                              engine_name.size());
@@ -2331,11 +2330,11 @@
 
 void sys_var_session_storage_engine::set_default(Session *session, enum_var_type type)
 {
-  st_plugin_int *old_value, *new_value, **value;
+  StorageEngine *old_value, *new_value, **value;
   if (type == OPT_GLOBAL)
   {
     value= &(global_system_variables.*offset);
-    new_value= ha_lock_engine(NULL, myisam_engine);
+    new_value= myisam_engine;
   }
   else
   {
@@ -2350,13 +2349,13 @@
 
 bool sys_var_session_storage_engine::update(Session *session, set_var *var)
 {
-  st_plugin_int **value= &(global_system_variables.*offset), *old_value;
+  StorageEngine **value= &(global_system_variables.*offset), *old_value;
    if (var->type != OPT_GLOBAL)
      value= &(session->variables.*offset);
   old_value= *value;
-  if (old_value != var->save_result.plugin)
+  if (old_value != var->save_result.storage_engine)
   {
-    *value= var->save_result.plugin;
+    *value= var->save_result.storage_engine;
   }
   return 0;
 }

=== modified file 'drizzled/set_var.h'
--- drizzled/set_var.h	2009-04-09 01:11:00 +0000
+++ drizzled/set_var.h	2009-04-09 05:35:58 +0000
@@ -604,10 +604,10 @@
 class sys_var_session_storage_engine :public sys_var_session
 {
 protected:
-  st_plugin_int *SV::*offset;
+  StorageEngine *SV::*offset;
 public:
   sys_var_session_storage_engine(sys_var_chain *chain, const char *name_arg,
-                                 st_plugin_int *SV::*offset_arg)
+                                 StorageEngine *SV::*offset_arg)
     :sys_var_session(name_arg), offset(offset_arg)
   { chain_sys_var(chain); }
   bool check(Session *session, set_var *var);
@@ -943,7 +943,7 @@
     uint32_t uint32_t_value;
     uint64_t uint64_t_value;
     size_t size_t_value;
-    st_plugin_int *plugin;
+    StorageEngine *storage_engine;
     Time_zone *time_zone;
     MY_LOCALE *locale_value;
   } save_result;

=== modified file 'drizzled/show.cc'
--- drizzled/show.cc	2009-04-09 05:42:03 +0000
+++ drizzled/show.cc	2009-04-09 23:30:44 +0000
@@ -65,6 +65,21 @@
 static void store_key_options(Session *session, String *packet, Table *table,
                               KEY *key_info);
 
+static vector<ST_SCHEMA_TABLE *> all_schema_tables;
+
+static void add_infoschema_table(ST_SCHEMA_TABLE *table)
+{
+  all_schema_tables.push_back(table);
+}
+
+static void remove_infoschema_table(ST_SCHEMA_TABLE *table)
+{
+  all_schema_tables.erase(remove_if(all_schema_tables.begin(),
+                                    all_schema_tables.end(),
+                                    bind2nd(equal_to<ST_SCHEMA_TABLE *>(),
+                                            table)),
+                          all_schema_tables.end());
+}
 
 
 int wild_case_compare(const CHARSET_INFO * const cs, const char *str,const char *wildstr)
@@ -1997,37 +2012,42 @@
 };
 
 
-static bool add_schema_table(Session *session, st_plugin_int *plugin,
-                                void* p_data)
+class AddSchemaTable : public unary_function<ST_SCHEMA_TABLE *, bool>
 {
-  LEX_STRING *file_name= 0;
-  st_add_schema_table *data= (st_add_schema_table *)p_data;
-  List<LEX_STRING> *file_list= data->files;
-  const char *wild= data->wild;
-  ST_SCHEMA_TABLE *schema_table= plugin_data(plugin, ST_SCHEMA_TABLE *);
-
-  if (schema_table->hidden)
-      return(0);
-  if (wild)
+  Session *session;
+  st_add_schema_table *data;
+public:
+  AddSchemaTable(Session *session_arg, st_add_schema_table *data_arg)
+    : session(session_arg), data(data_arg) {}
+  result_type operator() (argument_type schema_table)
   {
-    if (lower_case_table_names)
+    LEX_STRING *file_name= 0;
+    List<LEX_STRING> *file_list= data->files;
+    const char *wild= data->wild;
+  
+    if (schema_table->hidden)
+        return(0);
+    if (wild)
     {
-      if (wild_case_compare(files_charset_info,
-                            schema_table->table_name,
-                            wild))
+      if (lower_case_table_names)
+      {
+        if (wild_case_compare(files_charset_info,
+                              schema_table->table_name,
+                              wild))
+          return(0);
+      }
+      else if (wild_compare(schema_table->table_name, wild, 0))
         return(0);
     }
-    else if (wild_compare(schema_table->table_name, wild, 0))
+  
+    if ((file_name= session->make_lex_string(file_name, schema_table->table_name,
+                                         strlen(schema_table->table_name),
+                                         true)) &&
+        !file_list->push_back(file_name))
       return(0);
+    return(1);
   }
-
-  if ((file_name= session->make_lex_string(file_name, schema_table->table_name,
-                                       strlen(schema_table->table_name),
-                                       true)) &&
-      !file_list->push_back(file_name))
-    return(0);
-  return(1);
-}
+};
 
 
 int schema_tables_add(Session *session, List<LEX_STRING> *files, const char *wild)
@@ -2062,11 +2082,12 @@
 
   add_data.files= files;
   add_data.wild= wild;
-  if (plugin_foreach(session, add_schema_table,
-                     DRIZZLE_INFORMATION_SCHEMA_PLUGIN, &add_data))
-    return(1);
-
-  return(0);
+  vector<ST_SCHEMA_TABLE *>::iterator iter=
+    find_if(all_schema_tables.begin(), all_schema_tables.end(),
+           AddSchemaTable(session, &add_data));
+  if (iter != all_schema_tables.end())
+    return 1;
+  return 0 ;
 }
 
 
@@ -3635,10 +3656,18 @@
 }
 
 
-struct schema_table_ref
+class FindSchemaTableByName : public unary_function<ST_SCHEMA_TABLE *, bool>
 {
   const char *table_name;
-  ST_SCHEMA_TABLE *schema_table;
+public:
+  FindSchemaTableByName(const char *table_name_arg)
+    : table_name(table_name_arg) {}
+  result_type operator() (argument_type schema_table)
+  {
+    return !my_strcasecmp(system_charset_info,
+                          schema_table->table_name,
+                          table_name);
+  }
 };
 
 
@@ -3646,37 +3675,6 @@
   Find schema_tables elment by name
 
   SYNOPSIS
-    find_schema_table_in_plugin()
-    session                 thread handler
-    plugin              plugin
-    table_name          table name
-
-  RETURN
-    0	table not found
-    1   found the schema table
-*/
-static bool find_schema_table_in_plugin(Session *, st_plugin_int *plugin,
-                                        void* p_table)
-{
-  schema_table_ref *p_schema_table= (schema_table_ref *)p_table;
-  const char* table_name= p_schema_table->table_name;
-  ST_SCHEMA_TABLE *schema_table= plugin_data(plugin, ST_SCHEMA_TABLE *);
-
-  if (!my_strcasecmp(system_charset_info,
-                     schema_table->table_name,
-                     table_name)) {
-    p_schema_table->schema_table= schema_table;
-    return(1);
-  }
-
-  return(0);
-}
-
-
-/*
-  Find schema_tables elment by name
-
-  SYNOPSIS
     find_schema_table()
     session                 thread handler
     table_name          table name
@@ -3686,9 +3684,8 @@
     #   pointer to 'schema_tables' element
 */
 
-ST_SCHEMA_TABLE *find_schema_table(Session *session, const char* table_name)
+ST_SCHEMA_TABLE *find_schema_table(Session *, const char* table_name)
 {
-  schema_table_ref schema_table_a;
   ST_SCHEMA_TABLE *schema_table= schema_tables;
 
   for (; schema_table->table_name; schema_table++)
@@ -3699,11 +3696,11 @@
       return(schema_table);
   }
 
-  schema_table_a.table_name= table_name;
-  if (plugin_foreach(session, find_schema_table_in_plugin,
-                     DRIZZLE_INFORMATION_SCHEMA_PLUGIN, &schema_table_a))
-    return(schema_table_a.schema_table);
-
+  vector<ST_SCHEMA_TABLE *>::iterator iter= 
+    find_if(all_schema_tables.begin(), all_schema_tables.end(),
+            FindSchemaTableByName(table_name));
+  if (iter != all_schema_tables.end())
+    return *iter;
   return(NULL);
 }
 
@@ -4507,6 +4504,7 @@
     schema_table->table_name= plugin->name.str;
   }
 
+  add_infoschema_table(schema_table);
   plugin->data= schema_table;
 
   return 0;
@@ -4516,6 +4514,7 @@
 {
   ST_SCHEMA_TABLE *schema_table= (ST_SCHEMA_TABLE *)plugin->data;
 
+  remove_infoschema_table(schema_table);
   if (schema_table && plugin->plugin->deinit)
     plugin->plugin->deinit(schema_table);
 

=== modified file 'drizzled/sj_tmp_table.cc'
--- drizzled/sj_tmp_table.cc	2009-04-08 23:01:10 +0000
+++ drizzled/sj_tmp_table.cc	2009-04-09 23:30:44 +0000
@@ -186,14 +186,14 @@
   uint32_t reclength= field->pack_length();
   if (using_unique_constraint)
   {
-    share->db_plugin= ha_lock_engine(0, myisam_engine);
+    share->storage_engine= myisam_engine;
     table->file= get_new_handler(share, &table->mem_root,
                                  share->db_type());
     assert(uniq_tuple_length_arg <= table->file->max_key_length());
   }
   else
   {
-    share->db_plugin= ha_lock_engine(0, heap_engine);
+    share->storage_engine= heap_engine;
     table->file= get_new_handler(share, &table->mem_root,
                                  share->db_type());
   }

=== modified file 'drizzled/sql_base.cc'
--- drizzled/sql_base.cc	2009-04-09 05:42:03 +0000
+++ drizzled/sql_base.cc	2009-04-09 23:30:44 +0000
@@ -3596,6 +3596,19 @@
   return(error);
 }
 
+/*
+ * Helper function which tests whether a bit is set in the 
+ * bitset or not. It also sets the bit after this test is
+ * performed.
+ */
+static bool test_and_set_bit(bitset<MAX_FIELDS> *bitmap, uint32_t pos)
+{
+  bool ret= false;
+  if (bitmap->test(pos))
+    ret= true;
+  bitmap->set(pos);
+  return ret;
+}
 
 /*****************************************************************************
 * The following find_field_in_XXX procedures implement the core of the
@@ -3637,14 +3650,12 @@
       other_bitmap=   table->read_set;
     }
 
-    if (current_bitmap->test(field->field_index))
+    if (test_and_set_bit(current_bitmap, field->field_index))
     {
-      current_bitmap->set(field->field_index);
       if (session->mark_used_columns == MARK_COLUMNS_WRITE)
         session->dup_field= field;
       return;
     }
-    current_bitmap->set(field->field_index);
     if (table->get_fields_in_item_tree)
       field->flags|= GET_FIXED_FIELDS_FLAG;
     table->used_fields++;

=== modified file 'drizzled/sql_plugin.cc'
--- drizzled/sql_plugin.cc	2009-04-09 01:11:00 +0000
+++ drizzled/sql_plugin.cc	2009-04-09 05:35:58 +0000
@@ -718,14 +718,14 @@
       */
       if (my_strcasecmp(&my_charset_utf8_general_ci, plugin->name, "MyISAM") == 0)
       {
-        assert(!global_system_variables.table_plugin);
-        global_system_variables.table_plugin= plugin_ptr;
+        assert(!global_system_variables.storage_engine);
+        global_system_variables.storage_engine= static_cast<StorageEngine *>(plugin_ptr->data);
       }
     }
   }
 
   /* should now be set to MyISAM storage engine */
-  assert(global_system_variables.table_plugin);
+  assert(global_system_variables.storage_engine);
 
   /* Register all dynamic plugins */
   if (!(flags & PLUGIN_INIT_SKIP_DYNAMIC_LOADING))
@@ -1569,18 +1569,18 @@
 
 void plugin_sessionvar_init(Session *session)
 {
-  session->variables.table_plugin= NULL;
+  session->variables.storage_engine= NULL;
   cleanup_variables(session, &session->variables);
 
   session->variables= global_system_variables;
-  session->variables.table_plugin= NULL;
+  session->variables.storage_engine= NULL;
 
   /* we are going to allocate these lazily */
   session->variables.dynamic_variables_version= 0;
   session->variables.dynamic_variables_size= 0;
   session->variables.dynamic_variables_ptr= 0;
 
-  session->variables.table_plugin= global_system_variables.table_plugin;
+  session->variables.storage_engine= global_system_variables.storage_engine;
 }
 
 
@@ -1589,7 +1589,7 @@
 */
 static void unlock_variables(Session *, struct system_variables *vars)
 {
-  vars->table_plugin= NULL;
+  vars->storage_engine= NULL;
 }
 
 
@@ -1629,7 +1629,7 @@
   }
   pthread_rwlock_unlock(&LOCK_system_variables_hash);
 
-  assert(vars->table_plugin == NULL);
+  assert(vars->storage_engine == NULL);
 
   free(vars->dynamic_variables_ptr);
   vars->dynamic_variables_ptr= NULL;

=== modified file 'drizzled/sql_udf.cc'
--- drizzled/sql_udf.cc	2009-04-02 23:18:49 +0000
+++ drizzled/sql_udf.cc	2009-04-08 09:13:23 +0000
@@ -17,59 +17,29 @@
 #include <drizzled/server_includes.h>
 #include <drizzled/gettext.h>
 #include <drizzled/sql_udf.h>
+#include <drizzled/registry.h>
 
-#include <map>
 #include <string>
 
 using namespace std;
 
 static bool udf_startup= false; /* We do not lock because startup is single threaded */
-static map<string, Function_builder *> udf_map;
-
+static drizzled::Registry<Function_builder *> udf_registry;
 
 /* This is only called if using_udf_functions != 0 */
 Function_builder *find_udf(const char *name, uint32_t length)
 {
-
-  /**
-   * @todo: check without transform, then check with transform if needed
-   */
-  Function_builder *udf= NULL;
-
-  if (udf_startup == false)
-    return NULL;
-
-  string find_str(name, length);
-  transform(find_str.begin(), find_str.end(),
-            find_str.begin(), ::tolower);
-
-  map<string, Function_builder *>::iterator find_iter;
-  find_iter=  udf_map.find(find_str);
-  if (find_iter != udf_map.end())
-    udf= (*find_iter).second;
-
-  return (udf);
+  return udf_registry.find(name, length);
 }
 
 static bool add_udf(Function_builder *udf)
 {
-  /**
-   * @todo: add all lower and all upper version
-   */
-  string add_str= udf->get_name();
-  transform(add_str.begin(), add_str.end(),
-            add_str.begin(), ::tolower);
-
-  udf_map[add_str]= udf;
-
-  using_udf_functions= 1;
-
-  return true;
+  return udf_registry.add(udf);
 }
 
-static bool remove_udf(Function_builder *udf)
+static void remove_udf(Function_builder *udf)
 {
-  return udf_map.erase(udf->get_name());
+  udf_registry.remove(udf);
 }
 
 int initialize_udf(st_plugin_int *plugin)
@@ -92,7 +62,7 @@
   else
     return 1;
 
-  if (!add_udf(f))
+  if (add_udf(f))
     return 1;
 
   plugin->data= f;

=== modified file 'drizzled/sql_yacc.yy'
--- drizzled/sql_yacc.yy	2009-04-08 06:40:24 +0000
+++ drizzled/sql_yacc.yy	2009-04-08 11:02:54 +0000
@@ -1455,10 +1455,10 @@
 storage_engines:
           ident_or_text
           {
-            st_plugin_int *plugin= ha_resolve_by_name(YYSession, &$1);
+            StorageEngine *engine= ha_resolve_by_name(YYSession, &$1);
 
-            if (plugin)
-              $$= static_cast<StorageEngine *>(plugin->data);
+            if (engine)
+              $$= engine;
             else
             {
               my_error(ER_UNKNOWN_STORAGE_ENGINE, MYF(0), $1.str);
@@ -1470,9 +1470,9 @@
 known_storage_engines:
           ident_or_text
           {
-            st_plugin_int *plugin;
-            if ((plugin= ha_resolve_by_name(YYSession, &$1)))
-              $$= static_cast<StorageEngine *>(plugin->data);
+            StorageEngine *engine;
+            if ((engine= ha_resolve_by_name(YYSession, &$1)))
+              $$= engine;
             else
             {
               my_error(ER_UNKNOWN_STORAGE_ENGINE, MYF(0), $1.str);

=== modified file 'drizzled/table.cc'
--- drizzled/table.cc	2009-04-08 23:01:10 +0000
+++ drizzled/table.cc	2009-04-09 23:30:44 +0000
@@ -278,7 +278,7 @@
   }
   hash_free(&share->name_hash);
 
-  share->db_plugin= NULL;
+  share->storage_engine= NULL;
 
   /* We must copy mem_root from share because share is allocated through it */
   memcpy(&mem_root, &share->mem_root, sizeof(mem_root));
@@ -411,7 +411,7 @@
   {
     LEX_STRING engine_name= { (char*)table.engine().name().c_str(),
 			      strlen(table.engine().name().c_str()) };
-    share->db_plugin= ha_resolve_by_name(session, &engine_name);
+    share->storage_engine= ha_resolve_by_name(session, &engine_name);
   }
 
   share->mysql_version= DRIZZLE_VERSION_ID; // TODO: remove
@@ -4057,7 +4057,7 @@
       (select_options & (OPTION_BIG_TABLES | SELECT_SMALL_RESULT)) ==
       OPTION_BIG_TABLES || (select_options & TMP_TABLE_FORCE_MYISAM))
   {
-    share->db_plugin= ha_lock_engine(0, myisam_engine);
+    share->storage_engine= myisam_engine;
     table->file= get_new_handler(share, &table->mem_root,
                                  share->db_type());
     if (group &&
@@ -4067,7 +4067,7 @@
   }
   else
   {
-    share->db_plugin= ha_lock_engine(0, heap_engine);
+    share->storage_engine= heap_engine;
     table->file= get_new_handler(share, &table->mem_root,
                                  share->db_type());
   }
@@ -4754,7 +4754,7 @@
   new_table= *table;
   share= *table->s;
   new_table.s= &share;
-  new_table.s->db_plugin= ha_lock_engine(session, myisam_engine);
+  new_table.s->storage_engine= myisam_engine;
   if (!(new_table.file= get_new_handler(&share, &new_table.mem_root,
                                         new_table.s->db_type())))
     return(1);				// End of memory

=== modified file 'drizzled/table_share.h'
--- drizzled/table_share.h	2009-04-08 21:34:26 +0000
+++ drizzled/table_share.h	2009-04-09 23:30:44 +0000
@@ -87,11 +87,11 @@
   uint32_t   stored_rec_length;         /* Stored record length
                                            (no generated-only virtual fields) */
 
-  st_plugin_int *db_plugin;			/* storage engine plugin */
+  StorageEngine *storage_engine;			/* storage engine plugin */
   inline StorageEngine *db_type() const	/* table_type for handler */
   {
-    // assert(db_plugin);
-    return db_plugin ? static_cast<StorageEngine *>(db_plugin->data): NULL;
+    // assert(storage_engine);
+    return storage_engine;
   }
   enum row_type row_type;		/* How rows are stored */
   enum tmp_table_type tmp_table;

=== modified file 'plugin/oldlibdrizzle/net_serv.cc'
--- plugin/oldlibdrizzle/net_serv.cc	2009-04-07 20:25:40 +0000
+++ plugin/oldlibdrizzle/net_serv.cc	2009-04-09 21:12:06 +0000
@@ -477,10 +477,12 @@
   uint32_t retry_count= 0;
 
   /* Backup of the original SO_RCVTIMEO timeout */
+#ifdef WE_DONT_NEED_THIS_IN_DRIZZLED
 #ifndef __sun
   struct timespec backtime;
   int error;
 #endif
+#endif
 
   if (net->error == 2)
     return(-1);                /* socket can't be used */
@@ -534,6 +536,7 @@
     packet= b;
   }
 
+#ifdef WE_DONT_NEED_THIS_IN_DRIZZLED
 #ifndef __sun
   /* Check for error, currently assert */
   if (net->write_timeout)
@@ -558,6 +561,7 @@
     assert(error == 0);
   }
 #endif
+#endif
 
   pos= packet;
   end=pos+len;
@@ -610,11 +614,13 @@
     free((char*) packet);
   net->reading_or_writing=0;
 
+#ifdef WE_DONT_NEED_THIS_IN_DRIZZLED
 #ifndef __sun
   if (net->write_timeout)
     error= setsockopt(net->vio->sd, SOL_SOCKET, SO_RCVTIMEO,
                       &backtime, (socklen_t)sizeof(struct timespec));
 #endif
+#endif
 
   return(((int) (pos != end)));
 }
@@ -639,11 +645,13 @@
   uint32_t remain= (net->compress ? NET_HEADER_SIZE+COMP_HEADER_SIZE :
                     NET_HEADER_SIZE);
 
+#ifdef WE_DONT_NEED_THIS_IN_DRIZZLED
 #ifndef __sun
   /* Backup of the original SO_RCVTIMEO timeout */
   struct timespec backtime;
   int error= 0;
 #endif
+#endif
 
   *complen = 0;
 
@@ -653,6 +661,7 @@
   pos = net->buff + net->where_b;        /* net->packet -4 */
 
 
+#ifdef WE_DONT_NEED_THIS_IN_DRIZZLED
 #ifndef __sun
   /* Check for error, currently assert */
   if (net->read_timeout)
@@ -677,6 +686,7 @@
     assert(error == 0);
   }
 #endif
+#endif
 
   for (i= 0; i < 2 ; i++)
   {
@@ -746,11 +756,15 @@
   }
 
 end:
+#ifdef WE_DONT_NEED_THIS_IN_DRIZZLED
 #ifndef __sun
-  if  (net->read_timeout)
+  if  (net->vio->sd >= 0 && net->read_timeout)
+  {
     error= setsockopt(net->vio->sd, SOL_SOCKET, SO_RCVTIMEO,
                       &backtime, (socklen_t)sizeof(struct timespec));
-  assert(error == 0);
+    assert(error == 0);
+  }
+#endif
 #endif
   net->reading_or_writing= 0;
 

=== modified file 'plugin/oldlibdrizzle/oldlibdrizzle.cc'
--- plugin/oldlibdrizzle/oldlibdrizzle.cc	2009-04-08 00:00:15 +0000
+++ plugin/oldlibdrizzle/oldlibdrizzle.cc	2009-04-09 21:12:06 +0000
@@ -537,8 +537,12 @@
     the client, the connection is closed or "net_wait_timeout"
     number of seconds has passed
   */
+#ifdef NEVER
+  /* We can do this much more efficiently with poll timeouts or watcher thread,
+     disabling for now, which means net_wait_timeout == read_timeout. */
   drizzleclient_net_set_read_timeout(&net,
                                      session->variables.net_wait_timeout);
+#endif
 
   session->clear_error();
   session->main_da.reset_diagnostics_area();
@@ -585,9 +589,12 @@
   /* Do not rely on drizzleclient_net_read, extra safety against programming errors. */
   (*l_packet)[*packet_length]= '\0';                  /* safety */
 
+#ifdef NEVER
+  /* See comment above. */
   /* Restore read timeout value */
   drizzleclient_net_set_read_timeout(&net,
                                      session->variables.net_read_timeout);
+#endif
 
   return true;
 }
@@ -601,6 +608,12 @@
   }
 }
 
+void ProtocolOldLibdrizzle::forceClose(void)
+{
+  if (net.vio)
+    drizzleclient_vio_close(net.vio);
+}
+
 void ProtocolOldLibdrizzle::prepareForResend()
 {
   packet->length(0);

=== modified file 'plugin/oldlibdrizzle/oldlibdrizzle.h'
--- plugin/oldlibdrizzle/oldlibdrizzle.h	2009-04-08 00:00:15 +0000
+++ plugin/oldlibdrizzle/oldlibdrizzle.h	2009-04-09 07:39:41 +0000
@@ -74,7 +74,8 @@
   virtual void sendOK();
   virtual void sendEOF();
   virtual void sendError(uint32_t sql_errno, const char *err);
-  virtual void close(void);
+  virtual void close();
+  virtual void forceClose();
   virtual void prepareForResend();
   virtual void free();
   virtual bool write();

=== modified file 'plugin/pool_of_threads/plug.in'
--- plugin/pool_of_threads/plug.in	2009-03-04 02:28:24 +0000
+++ plugin/pool_of_threads/plug.in	2009-04-08 22:56:47 +0000
@@ -20,5 +20,5 @@
   ]) 
   AS_IF([test x$ac_cv_libevent = xno],
       AC_MSG_ERROR([A recent libevent is required for Drizzle. Check http://www.monkey.org/~provos/libevent ]))
-  DRIZZLED_PLUGIN_DEP_LIBS="${DRIZZLED_PLUGIN_DEP_LIBS} ${LIBEVENT}"
+  DRIZZLED_PLUGIN_DEP_LIBS="${DRIZZLED_PLUGIN_DEP_LIBS} ${LTLIBEVENT}"
 ])

=== modified file 'storage/heap/ha_heap.cc'
--- storage/heap/ha_heap.cc	2009-03-26 08:22:57 +0000
+++ storage/heap/ha_heap.cc	2009-04-08 09:42:38 +0000
@@ -37,7 +37,11 @@
 class HeapEngine : public StorageEngine
 {
 public:
-  HeapEngine(string name_arg) : StorageEngine(name_arg, HTON_CAN_RECREATE) {}
+  HeapEngine(string name_arg) : StorageEngine(name_arg, HTON_CAN_RECREATE)
+  {
+    addAlias("HEAP");
+  }
+
   virtual handler *create(TABLE_SHARE *table,
                           MEM_ROOT *mem_root)
   {

=== modified file 'storage/innobase/handler/ha_innodb.cc'
--- storage/innobase/handler/ha_innodb.cc	2009-04-08 21:34:26 +0000
+++ storage/innobase/handler/ha_innodb.cc	2009-04-09 23:30:44 +0000
@@ -220,7 +220,10 @@
 {
 public:
   InnobaseEngine(string name_arg)
-   : StorageEngine(name_arg, HTON_NO_FLAGS, sizeof(trx_named_savept_t)) {}
+   : StorageEngine(name_arg, HTON_NO_FLAGS, sizeof(trx_named_savept_t))
+  {
+    addAlias("INNOBASE");
+  }
 
   virtual
   int

=== modified file 'tests/r/information_schema.result'
--- tests/r/information_schema.result	2009-03-20 05:35:22 +0000
+++ tests/r/information_schema.result	2009-04-09 05:21:50 +0000
@@ -260,13 +260,13 @@
 STATISTICS	TABLE_SCHEMA
 TABLES	TABLE_SCHEMA
 TABLE_CONSTRAINTS	CONSTRAINT_SCHEMA
+INNODB_TRX	trx_id
+INNODB_LOCKS	lock_id
+INNODB_LOCK_WAITS	requesting_trx_id
 INNODB_CMP	page_size
 INNODB_CMP_RESET	page_size
 INNODB_CMPMEM	page_size
 INNODB_CMPMEM_RESET	page_size
-INNODB_LOCK_WAITS	requesting_trx_id
-INNODB_LOCKS	lock_id
-INNODB_TRX	trx_id
 SELECT t.table_name, c1.column_name
 FROM information_schema.tables t
 INNER JOIN
@@ -299,13 +299,13 @@
 STATISTICS	TABLE_SCHEMA
 TABLES	TABLE_SCHEMA
 TABLE_CONSTRAINTS	CONSTRAINT_SCHEMA
+INNODB_TRX	trx_id
+INNODB_LOCKS	lock_id
+INNODB_LOCK_WAITS	requesting_trx_id
 INNODB_CMP	page_size
 INNODB_CMP_RESET	page_size
 INNODB_CMPMEM	page_size
 INNODB_CMPMEM_RESET	page_size
-INNODB_LOCK_WAITS	requesting_trx_id
-INNODB_LOCKS	lock_id
-INNODB_TRX	trx_id
 SELECT MAX(table_name) FROM information_schema.tables;
 MAX(table_name)
 TABLE_CONSTRAINTS

=== modified file 'tests/suite/broken/t/init_connect.test'
--- tests/suite/broken/t/init_connect.test	2009-04-07 06:07:18 +0000
+++ tests/suite/broken/t/init_connect.test	2009-04-09 14:55:37 +0000
@@ -28,7 +28,7 @@
 set GLOBAL init_connect="adsfsdfsdfs";
 connect (con5,localhost,user_1,,);
 connection con5;
---error 20,21
+--error 5,20,21
 select @a;
 connection con0;
 drop table t1;

